'######################################################################
'# Firmware fr Sparmatic Zero v. 0.1.1                               #
'#                                                                    #
'# Verwendung auf eigene Gefahr! Die Schaltung enthlt eine H-Brcke. #
'# PortG.3 und PortG.4 drfen niemals gleichzeitig 1 sein, da sonst   #
'# ein Kurzschluss entsteht, der Beschdigungen zur Folge haben kann! #
'# Ich bernehme keine Haftung.                                       #
'######################################################################

$regfile = "m169def.dat"                                    ' specify the used micro
$hwstack = 45                                               '32                                               ' default use 32 for the hardware stack
$swstack = 20                                               '10                                               ' default use 10 for the SW stack
$framesize = 55                                             '45                                             ' default use 40 for the frame space
$crystal = 1000000                                          ' used crystal frequency/clockdiv
Config Clockdiv = 8

Const Test = 1
Const Eeprom_version = 1
$eepleave
'##########################################################################
'### Aliase und Variablen fr Programmschritte in extra Datei
'##########################################################################
$include "prg_steps_def.bas"

'##########################################################################
'### Config Variablen
'##########################################################################
Impulsgeber_enable Alias Porte.3
Impulsgeber_port Alias Porte.1
Impulsgeber_pin Alias Pine.1
Config Impulsgeber_enable = Output
Config Impulsgeber_port = Input
Pcmsk0 = &B00000010                                         ' Interruptmaske setzen
On Pcint0 Impulsgeber_int                                   ' und Interruptziel angeben

'### Globale Flags
Dim Gl_status As Word                                       ' Globale Bit-Hilfsvariable
New_minute Alias Gl_status.0                                ' Jede Minute von Sec_tick gesetzt
Messfahrt_noetig Alias Gl_status.1
Messfahrt_interaktiv Alias Gl_status.2
Rfm12ok Alias Gl_status.15                                  ' Flag ob RFM12 da/bereit
Set Messfahrt_noetig
Set Messfahrt_interaktiv

'### Temperaturvariablen       in 1/10 Grad Celsius
Dim Temperatur_normal As Integer
Dim Temperatur_spar As Integer
Dim Temperatur_frost As Integer
Dim Temperatur_ist As Integer
Dim Temperatur_soll As Integer

'### Ventilvariablen
Ventil_zu Alias Portg.3
Ventil_auf Alias Portg.4
Config Ventil_auf = Output                                  ' Motor Richtung auf
Config Ventil_zu = Output                                   ' Motor Richtung zu
Reset Ventil_auf
Reset Ventil_zu
Dim Ventilwert_ist As Integer
Dim Ventilwert_soll As Integer
Dim Ventilwert_auf As Integer
Dim Ventilwert_zu As Integer
Ventilwert_auf = 0

'### Schaltzeitenvariablen
Const Timer_count = 21
Dim Timer_pointer As Byte
Dim Timer_dow As Byte                                       'DOW=day of week
Dim Timer_active As Byte                                    'bit0=aktiv;bit1=Montag..bit7=sonntag
Dim Timer_hour As Byte
Dim Timer_min As Byte
Dim Timer_temperatur As Integer

'### Hilfsvariablen
Dim Wert1_b As Byte                                         ' Byte Hilfsvariable
Dim Wert2_b As Byte                                         ' Byte Hilfsvariable
'Dim Wert3_b As Byte                                         ' Byte Hilfsvariable
Dim Count As Integer                                        ' Integer Hilfsvariable
Dim Wert1_i As Integer                                      ' Integer Hilfsvariable
Dim Wert2_i As Integer                                      ' Integer Hilfsvariable
'Dim Wert3_i As Integer                                      ' Integer Hilfsvariable
Dim Wert1_w As Word                                         ' Integer Hilfsvariable
Dim Wert2_w As Word                                         ' Integer Hilfsvariable
Dim Wert3_w As Word                                         ' Integer Hilfsvariable
Dim Wert1_l As Long

'### Timer0 konfigurieren (Motor Notaus)
Config Timer0 = Timer , Prescale = 1024
Stop Timer0
Timer0 = 0
On Timer0 Timer0_int                                        ' Interruptziel angeben
Enable Timer0
Dim Impulscounter As Word
Dim Leerlaufticks As Word
Dim Pin_offset As Byte
Dim Close_offset As Byte

'### Timer1 konfigurieren (Tastenerkennung)
Config Timer1 = Timer , Prescale = 1
Start Timer1
Timer1 = 0
On Timer1 Timer1_int                                        ' Interruptziel angeben
Enable Timer1
Enable Interrupts

'### Tastendefinition
K_plus Alias 0
K_minus Alias 4
K_prog Alias 5
K_temp Alias 6
K_manu Alias 7
Keypressed Alias 1
Longpressed Alias 2
Datetimesetup Alias &B00100110                              'Prog-Taste lange gedrckt halten
Timersetup Alias &B10100110                                 'Prog+manu lange gedrckt halten
Setup Alias &B01100110                                      'Prog+Temp lange gedrckt halten
Dim Key_pressed_counter As Byte
Dim Entprell_helper As Byte
Dim Key As Byte
Dim Tempkey As Byte
Dim Readkey As Byte
Key_port Alias Portb
Config Key_port = Input
Key_port = &B11110001                                       'Pullups setzen

'### LCD Configs
Dim Lcd_count As Byte , Lcd_muster As Byte , Lcd_upper As Byte , Lcd_lower As Byte
Dim Temp_lcddr5 As Byte , Temp_lcddr6 As Byte , Temp_lcddr7 As Byte , Temp_lcddr10 As Byte , Temp_lcddr11 As Byte , Temp_lcddr12 As Byte
Dim Lcd_balkenwert_von As Byte
Dim Lcd_balkenwert_bis As Byte
Dim Lcd_text As String * 5
Dim Lcd_text_alt As String * 5
Dim Lcd_textchar(5) As Byte At Lcd_text Overlay
Dim Lcd_countdown As Byte
Lcdcrb = &B10110101                                         ' 32767Hc Osc., Bias 1/3, Duty 1/3, Port
Lcdfrr = &B00000110                                         ' Prescale 32767/16/7=49Hc LCD clock rat
Lcdccr = &B00001110                                         ' LCD Power 3.3 V (Contrast)
Lcdcra = &B10000000                                         ' LCD on
Lcd_skala Alias Lcddr0.0                                    'LCD Aliase
Lcd_auto Alias Lcddr5.1
Lcd_manu Alias Lcddr10.2
Lcd_prog Alias Lcddr5.2
Lcd_batt Alias Lcddr10.1
Lcd_sonne Alias Lcddr7.4
Lcd_mond Alias Lcddr12.4
Lcd_frost Alias Lcddr7.3
Lcd_funk Alias Lcddr12.3
Set Lcd_auto

'### Uhr parametrieren
Config Clock = Soft , Gosub = Sectic
Config Date = Dmy , Separator = .
_year = 10                                                  'Ein paar Standardwerte vorgeben
_month = 8
_day = 30
_hour = 12
_min = 0

'### ADC-Wandler parametrieren
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Ntcport Alias Portf.2                                       ' Spannungsversorung des NTC
Config Ntcport = Output
Dim Battpower As Integer                                    ' Batteriespannung in hundertstel Volt
Dim Batt_warnlevel As Byte                                  ' Batteriewarnspannung in hundertstel Volt
Dim Batt_emptylevel As Byte                                 ' Batterieleerspannung in hundertstel Volt

'### PI-Regler Variablen/Konstanten
Dim Kp As Byte
Dim Ki As Byte
Dim Reglerabweichung As Integer
Dim I_anteil_alt As Integer
I_anteil_alt = 0

'##########################################################################
'### Initialisieren der Daten
'##########################################################################
Init:
Reset Ntcport                                               ' NTC abschalten

'### Daten aus EEPROM lesen

Dim Ee_dummy As Eram Byte                                   'Dummy-Byte
Dim Ee_firststart As Eram Byte
Dim Ee_temperatur_normal As Eram Integer                    'Temperatur in 1/10 Grad
Dim Ee_temperatur_spar As Eram Integer
Dim Ee_temperatur_frost As Eram Integer
Dim Ee_kp As Eram Byte
Dim Ee_ki As Eram Byte
Dim Ee_batt_warnlevel As Eram Byte                          ' Batteriewarnspannung in hundertstel Volt
Dim Ee_batt_emptylevel As Eram Byte                         ' Batterieleerspannung in hundertstel Volt
Dim Ee_pin_offset As Eram Byte
Dim Ee_close_offset As Eram Byte
Dim Ee_timer_active(timer_count) As Eram Byte               'bit0=aktiv;bit1=Montag..bit7=sonntag
Dim Ee_timer_hour(timer_count) As Eram Byte
Dim Ee_timer_min(timer_count) As Eram Byte
Dim Ee_timer_temperatur(timer_count) As Eram Integer
If Ee_firststart <> Eeprom_version Then                     ' wenn FF, dann Daten ungltig, standardwerte ins eeprom schreiben
   Ee_temperatur_normal = 220                               'Temperatur in 1/10 Grad
   Ee_temperatur_spar = 170
   Ee_temperatur_frost = 60
   Ee_ki = 1
   Ee_kp = 3
   Ee_batt_warnlevel = 240
   Ee_batt_emptylevel = 220
   Ee_pin_offset = 3
   Ee_close_offset = 6
   For Wert1_b = 1 To Timer_count
      Ee_timer_active(wert1_b) = 0
      Ee_timer_hour(wert1_b) = 12
      Ee_timer_min(wert1_b) = 0
      Ee_timer_temperatur(wert1_b) = 220
   Next
   Ee_firststart = Eeprom_version
End If
Temperatur_normal = Ee_temperatur_normal                    ' Integer einlesen
Temperatur_spar = Ee_temperatur_spar                        ' Integer einlesen
Temperatur_frost = Ee_temperatur_frost
Temperatur_soll = Temperatur_spar
Ki = Ee_ki
Kp = Ee_kp
Batt_warnlevel = Ee_batt_warnlevel
Batt_emptylevel = Ee_batt_emptylevel
Pin_offset = Ee_pin_offset
Close_offset = Ee_close_offset

'###RFM12 Init

'Pinbelegung:
'EuroZero <--> RFM12
'1 VCC         VCC
'2 RESET       Not Connected
'3 PortF.4     SDI
'4 PortF.5     SCK
'5 PortF.6     nSEL
'6 PortF.7     SDO
'7 GND         GND

'   Declare Sub Spi16
'   Dim Rfm12_dataword As Word
'   Dim Data_in(10) As Byte
'   Nsel Alias Portf.6
'   Sdi Alias Portf.4
'   Sdo Alias Pinf.7
'   Sck Alias Portf.5
'   Config Nsel = Output
'   Config Sdi = Output
'   Config Sck = Output

'   'Init RFM12 (egal, ob vorhanden oder nicht)
'   Nsel = 1
'   Waitms 100
'   Restore Rfm12_init
'   For Wert1_b = 1 To 12
'      Read Rfm12_dataword
'      Spi16
'   Next

'   'RMF12 erkennen
'   Config Clockdiv = 1
'   Rfm12_dataword = &H8238
'   Spi16
'   Nsel = 0
'   Waitms 1
'   If Sdo = 1 Then
'      Rfm12ok = 1
'      Lcd_funk = 1
'      '...
'   End If
'   Config Clockdiv = 8




Prg_step = Prg_first_start
#if Test
   Messfahrt_interaktiv = 0
   Prg_step = Prg_messfahrt_ventil_open
#endif


'##########################################################################
'### Start der Hauptschleife
'##########################################################################
Main:

Key = Tempkey                                               'Tastenstatus zu beginn der Mainloop lesen...
Tempkey = 0                                                 'und zurcksetzen
Tempkey.keypressed = Key.keypressed

Select Case Prg_step
   Case Prg_wait_for_key                                    ' hier wird auf ne Taste gewartet
      If Key.keypressed = 1 Then Prg_step = Prg_next_step

   Case Prg_wait_for_no_key                                 ' hier wird auf das loslassen der Taste(n) gewartet
      If Key.keypressed = 0 Then Prg_step = Prg_next_step

   Case Prg_wait_for_stop
      If Ventil_auf = 0 And Ventil_zu = 0 Then Prg_step = Prg_next_step

   Case Prg_select_value                                    ' Routine zum setzen von Werten durch den Anwender
      Lcd_text = Value_format
      Wert1_i = Value
      Wert1_b = 4
      Do
         If Lcd_textchar(wert1_b) = 63 Then
            Wert2_i = Wert1_i Mod 10
            If _sec.0 = 0 And Tempkey.keypressed = 0 Then Lcd_textchar(wert1_b) = 32 Else Lcd_textchar(wert1_b) = Wert2_i + 48       ' = 48
            Wert1_i = Wert1_i \ 10
         End If
         Decr Wert1_b
      Loop Until Wert1_b = 0
      If Key.k_minus = 1 Then
         If Value > Value_min Then Value = Value - Value_change Else Value = Value_max
      End If
      If Key.k_plus = 1 Then
         If Value < Value_max Then Value = Value + Value_change Else Value = Value_min
      End If
      If Key.k_prog = 1 Then
         If Value_ready = 1 Then
            Value_ready = 0
            Prg_step = Prg_return_to
         Else
            Prg_step = Prg_wait_for_no_key
            Prg_next_step = Prg_select_value
            Value_ready = 1
         End If
      End If
      If Value_format = "???#." Then                        'Temperaturspezifische Dinge
         Lcd_textchar(4) = 35
         Lcd_textchar(5) = 46
         If Prg_return_to = Prg_save_temperatur_soll Then
            If Lcd_countdown = 0 Then Prg_step = Prg_return_to
            If Key.keypressed = 1 Then Lcd_countdown = 5
         End If
         If Prg_return_to = Prg_save_temperatur_soll Or Prg_return_to = Prg_save_timer_eeprom Then
            If Key.k_temp = 1 Then
               If Lcd_sonne = 1 Then Value = Temperatur_spar Else Value = Temperatur_normal
            End If
            Reset Lcd_sonne
            Reset Lcd_mond
            Reset Lcd_frost
            If Value = Temperatur_frost Then Set Lcd_frost
            If Value = Temperatur_spar Then Set Lcd_mond
            If Value = Temperatur_normal Then Set Lcd_sonne
         End If
      End If
      If Value_format = "Ti??:" Then                        'TimerSelectSpezifische Dinge
         If Value = 0 Then Lcd_text = "CALI "
         If Value = Timer_count Then
            Lcd_text = "END  "
            If Key.k_prog = 1 Then Prg_step = Prg_normalfunktion
         End If
      End If
      If Value_format = "D1??:" Then                        'TimerActiveSpezifische Dinge
         If Timer_dow = 0 Then Lcd_text = "ON  :" Else Lcd_text = "D" + Str(timer_dow) + "  :"
         If Value = 0 Then Lcd_textchar(4) = "N" Else Lcd_textchar(4) = "Y"
      End If

   Case Prg_first_start
      Prg_step = Prg_set_day

   Case Prg_set_day
      Value = _day
      Value_min = 1
      Value_max = 31
      Value_change = 1
      If _month < 10 Then Value_format = "??0" + Str(_month) + "." Else Value_format = "??" + Str(_month) + "."
      Prg_step = Prg_select_value
      Prg_return_to = Prg_set_month

   Case Prg_set_month
      _day = Value
      Value = _month
      Value_max = 12
      If _day < 10 Then Value_format = "0" + Str(_day) + "??." Else Value_format = Str(_day) + "??."
      Prg_step = Prg_select_value
      Prg_return_to = Prg_set_year

   Case Prg_set_year
      _month = Value
      Value = _year
      Value_min = 10
      Value_max = 99
      Value_format = "20?? "
      Prg_step = Prg_select_value
      Prg_return_to = Prg_set_hour

   Case Prg_set_hour
      _year = Value
      Value = _hour
      Value_min = 0
      Value_max = 23
      If _min < 10 Then Value_format = "??0" + Str(_min) + ":" Else Value_format = "??" + Str(_min) + ":"
      Prg_step = Prg_select_value
      Prg_return_to = Prg_set_min

   Case Prg_set_min
      _hour = Value
      Value = _min
      Value_max = 59
      If _hour < 10 Then Value_format = "0" + Str(_hour) + "??:" Else Value_format = Str(_hour) + "??:"
      Prg_step = Prg_select_value
      Prg_return_to = Prg_first_start_messfahrt

   Case Prg_first_start_messfahrt
      _min = Value
      If Messfahrt_noetig = 1 Then Prg_step = Prg_messfahrt_ventil_open Else Prg_step = Prg_normalfunktion

   Case Prg_save_temperatur_soll
      Temperatur_soll = Value
      Prg_step = Prg_normalfunktion

   Case Prg_save_timer_pointer
      Timer_pointer = Value
      Timer_active = Ee_timer_active(timer_pointer)
      Timer_temperatur = Ee_timer_temperatur(timer_pointer)
      Timer_hour = Ee_timer_hour(timer_pointer)
      Timer_min = Ee_timer_min(timer_pointer)
      Value = Timer_active.0
      Value_min = 0
      Value_max = 1
      Value_format = "D1??:"
      Timer_dow = 0
      Prg_return_to = Prg_save_timer_active
      Prg_step = Prg_select_value

   Case Prg_save_timer_active
      Timer_active.timer_dow = Value
      Incr Timer_dow
      Value = Timer_active.timer_dow
      If Timer_dow = 8 Then
         Value = Timer_hour
         Value_min = 0
         Value_max = 23
         If Timer_min < 10 Then Value_format = "??0" + Str(timer_min) + ":" Else Value_format = "??" + Str(timer_min) + ":"
         Prg_step = Prg_select_value
         Prg_return_to = Prg_save_timer_hour
      Else
         Prg_step = Prg_select_value
      End If
      If Timer_active.0 = 0 Then                            'wenn timer abgeschaltet, dann nicht nach wochentagen, uhrzeit und temperatur fragen.
         Prg_step = Prg_save_timer_eeprom
         Value = Timer_temperatur
      End If

   Case Prg_save_timer_hour
      Timer_hour = Value
      Value = Timer_min
      Value_min = 0
      Value_max = 59
      If Timer_hour < 10 Then Value_format = "0" + Str(timer_hour) + "??:" Else Value_format = Str(timer_hour) + "??:"
      Prg_step = Prg_select_value
      Prg_return_to = Prg_save_timer_min

   Case Prg_save_timer_min
      Timer_min = Value
      Value = Timer_temperatur
      Value_change = 5
      Value_min = 0
      Value_max = 300
      Value_format = "???#."
      Prg_step = Prg_select_value
      Prg_return_to = Prg_save_timer_eeprom
      If Timer_pointer = 0 Then Prg_step = Prg_save_timer_eeprom       'wenn cali, dann nicht nach temperatur fragen.

   Case Prg_save_timer_eeprom
      Timer_temperatur = Value
      Ee_timer_active(timer_pointer) = Timer_active
      Ee_timer_temperatur(timer_pointer) = Timer_temperatur
      Ee_timer_hour(timer_pointer) = Timer_hour
      Ee_timer_min(timer_pointer) = Timer_min
      Value = Timer_pointer
      Value_min = 0
      Value_max = Timer_count
      Value_change = 1
      Value_format = "Ti??:"
      Prg_return_to = Prg_save_timer_pointer
      Prg_step = Prg_select_value

   Case Prg_save_temperatur_normal
      Ee_temperatur_normal = Value
      Temperatur_normal = Value
      Value = Temperatur_spar
      Reset Lcd_sonne
      Set Lcd_mond
      Prg_return_to = Prg_save_temperatur_spar
      Prg_step = Prg_select_value

   Case Prg_save_temperatur_spar
      Ee_temperatur_spar = Value
      Temperatur_spar = Value
      Value = Temperatur_frost
      Reset Lcd_mond
      Set Lcd_frost
      Prg_return_to = Prg_save_temperatur_frost
      Prg_step = Prg_select_value

   Case Prg_save_temperatur_frost
      Reset Lcd_frost
      Ee_temperatur_frost = Value
      Temperatur_frost = Value
      Value = Kp
      Value_max = 99
      Value_min = 1
      Value_change = 1
      Value_format = "RP??:"
      Prg_return_to = Prg_save_kp
      Prg_step = Prg_select_value

   Case Prg_save_kp
      Ee_kp = Value
      Kp = Value
      Value = Ki
      Value_max = Kp
      Value_format = "RI??:"
      Prg_return_to = Prg_save_ki
      Prg_step = Prg_select_value

   Case Prg_save_ki
      Ee_ki = Value
      Ki = Value
      Value = Batt_warnlevel / 10
      Value_max = 25
      Value_min = 10
      Value_format = "BL??:"
      Prg_return_to = Prg_save_batt_low
      Prg_step = Prg_select_value

   Case Prg_save_batt_low
      Batt_warnlevel = Value * 10
      Ee_batt_warnlevel = Batt_warnlevel
      Value = Batt_emptylevel / 10
      Value_max = Batt_warnlevel / 10
      Value_format = "BE??:"
      Prg_return_to = Prg_save_batt_empty
      Prg_step = Prg_select_value

   Case Prg_save_batt_empty
      Batt_emptylevel = Value / 10
      Ee_batt_emptylevel = Batt_emptylevel
      Value_min = 1
      Value_max = 10
      Value_format = "CP??:"
      Value = Pin_offset
      Prg_return_to = Prg_save_pin_offset
      Prg_step = Prg_select_value

   Case Prg_save_pin_offset
      Ee_pin_offset = Value
      Pin_offset = Value
      Value_min = Pin_offset + 1
      Value_format = "CC??:"
      Value = Close_offset
      Prg_return_to = Prg_save_close_offset
      Prg_step = Prg_select_value

   Case Prg_save_close_offset
      Ee_close_offset = Value
      Close_offset = Value
      Prg_step = Prg_normalfunktion

   Case Prg_messfahrt_ventil_open
      Ventilwert_ist = 0
      Ventilwert_soll = 9999
      Ventilwert_auf = 0
      Ventilwert_zu = 0
      Lcd_text = "OPEN"
      Prg_step = Prg_set_ventil
      Prg_next_step = Prg_messfahrt_check_interactive

   Case Prg_messfahrt_check_interactive
      If Messfahrt_interaktiv = 1 Then                      ' Warte bei Erstinst auf User
         Lcd_text = "INST"
         Prg_step = Prg_wait_for_key
         Prg_next_step = Prg_messfahrt_ventil_close
      Else
         Waitms 200
         Prg_step = Prg_messfahrt_ventil_close
      End If

   Case Prg_messfahrt_ventil_close                          ' Ventil jetzt zufahren
      Ventilwert_ist = 9999
      Ventilwert_soll = 0
      Leerlaufticks = 9999
      Lcd_text = "CLOS"
      Prg_step = Prg_set_ventil
      Prg_next_step = Prg_messfahrt_calc_steps

   Case Prg_messfahrt_calc_steps                            ' Ermitteln des Fahrweges von Auf bis Zu
      Ventilwert_auf = Ventilwert_auf - Ventilwert_zu
      Ventilwert_zu = 0
      Ventilwert_ist = Ventilwert_zu
      Ventilwert_soll = Ventilwert_zu
      Messfahrt_interaktiv = 0
      Messfahrt_noetig = 0
      Prg_step = Prg_msr
      #if Test
         Reset Lcd_sonne
         Reset Lcd_mond
         Lcd_text = Str(ventilwert_auf)
         Lcd_countdown = 5
         'Prg_step = Prg_normalfunktion
      #endif

   Case Prg_normalfunktion
      If Lcd_countdown = 0 Then
         Reset Lcd_sonne
         Reset Lcd_mond
         Reset Lcd_frost
         If Temperatur_soll = Temperatur_frost Then Set Lcd_frost
         If Temperatur_soll = Temperatur_spar Then Set Lcd_mond
         If Temperatur_soll = Temperatur_normal Then Set Lcd_sonne

         If _sec.2 = 1 Then                                 'Abwechselnd Temperatur und Uhrzeit anzeigen
            Select Case Temperatur_ist
               Case Is < 100 : Lcd_text = "0" + Str(temperatur_ist)
               Case 5 : Lcd_text = "005"
               Case 0 : Lcd_text = "000"
               Case Is < 0 : Lcd_text = "-" + Str(temperatur_ist)
               Case Else : Lcd_text = Str(temperatur_ist)
            End Select
            Lcd_textchar(4) = 35
            Lcd_textchar(5) = 46
            #if Test
               If _sec.1 = 1 Then
                  Lcd_text = "     "
'                  Lcd_text = "U" + Str(battpower) +"."     'DEBUG: Spannung anzeigen
                  Lcd_text = "i" + Str(ventilwert_ist)      'DEBUG: Ventil_ist anzeigen
               End If
            #endif
         Else
            If _hour < 10 Then Lcd_text = "0" + Str(_hour) Else Lcd_text = Str(_hour)
            If _min < 10 Then Lcd_text = Lcd_text + "0" + Str(_min) Else Lcd_text = Lcd_text + Str(_min)
            If _sec.0 = 1 Then Lcd_textchar(5) = 58         'Blinkender Doppelpunkt bei uhrzeit
         End If
         If Key.k_prog = 1 Then                             'setup?
            If Key = Datetimesetup Then Prg_step = Prg_set_day
            If Key = Timersetup Then
               Value = 0
               Value_min = 0
               Value_max = Timer_count
               Value_change = 1
               Value_format = "Ti??:"
               Prg_return_to = Prg_save_timer_pointer
               Prg_step = Prg_select_value
            End If
            If Key = Setup Then
               Set Lcd_sonne
               Reset Lcd_mond
               Reset Lcd_frost
               Value = Temperatur_normal
               Value_min = 0
               Value_max = 300
               Value_change = 5
               Value_format = "???#."
               Prg_return_to = Prg_save_temperatur_normal
               Prg_step = Prg_select_value
            End If
         Else
            If Key.k_manu = 1 Then
               If Lcd_manu = 1 Then
                  Set Lcd_auto
                  Reset Lcd_manu
               Else
                  Set Lcd_manu
                  Reset Lcd_auto
               End If
            End If
            If Key.k_plus = 1 Or Key.k_minus = 1 Or Key.k_temp = 1 Then
               Value = Temperatur_soll
               Value_min = 0
               Value_max = 300
               Value_change = 5
               Value_format = "???#."
               Prg_return_to = Prg_save_temperatur_soll
               Lcd_countdown = 5
               Prg_step = Prg_select_value
            End If
         End If
         If _sec = 59 Then Set New_minute
         If _sec = 0 And New_minute = 1 Then Prg_step = Prg_msr
'         If Prg_step = Prg_normalfunktion Then Config clockdiv = 256 Else Config Clockdiv = 8
      End If

   Case Prg_msr
      Reset New_minute
      Set Ntcport                                           ' NTC einschalten
      Start Adc                                             ' ADC-Modul starten
      Waitus 70
      Wert1_i = Getadc(30)                                  ' Bandgap gegen Avcc messen
      Wert1_l = 1126400000 \ Wert1_i
      Wert1_l = Wert1_l \ 10000
      Battpower = Wert1_l

      If Battpower <= Batt_warnlevel Then Set Lcd_batt Else Reset Lcd_batt
      If Battpower <= Batt_emptylevel Then Prg_step = Prg_battery_empty

      Wert1_w = Getadc(0)                                   ' Temperatur messen
      Reset Ntcport                                         ' NTC spannungslos machen
      Stop Adc                                              ' ADC-Modul abschalten
      Restore Adc_val                                       ' Tabelle zurcksetzen
      Count = 0                                             ' Zhler lschen
      Read Wert3_w                                          ' und Wert vorbesetzen
      Do
         Wert2_w = Wert3_w
         Read Wert3_w
         Incr Count
      Loop Until Wert3_w > Wert1_w
      Temperatur_ist = Count * 50
      Temperatur_ist = 600 - Temperatur_ist                 'auf nchsthhere 5 aufgerunded
      Wert3_w = Wert3_w - Wert2_w                           'Den Wert zwischen den 5Grad-Werten wird linear ermittelt
      Wert3_w = 50000 / Wert3_w
      Wert2_w = Wert1_w - Wert2_w
      Wert2_w = Wert2_w * Wert3_w
      Wert2_w = Wert2_w / 1000
      Temperatur_ist = Temperatur_ist - Wert2_w             'Von der aufgerundeten Temperatur den linearen Wert abziehen.

      'Schaltzeiten berprfen
      If Lcd_auto = 1 Then
         Wert2_b = Dayofweek()
         Incr Wert2_b
         For Wert1_b = 1 To Timer_count
            Timer_active = Ee_timer_active(wert1_b)
            Timer_temperatur = Ee_timer_temperatur(wert1_b)
            Timer_hour = Ee_timer_hour(wert1_b)
            Timer_min = Ee_timer_min(wert1_b)
            If Timer_active.0 = 1 And Timer_active.wert2_b = 1 And Timer_hour = _hour And Timer_min = _min Then
               If Wert1_b = 0 Then Messfahrt_noetig = 1 Else Temperatur_soll = Timer_temperatur
            End If
         Next
      End If

'      '###PI-Regler
      Reglerabweichung = Temperatur_soll - Temperatur_ist   ' Temperaturabweichung
      Wert1_i = 0
      If Reglerabweichung >= 10 Or Reglerabweichung < 0 Then Wert1_i = Reglerabweichung * Kp       ' P-Anteil, wenn min. ein grad zu kalt oder zu warm.
      Wert2_i = Reglerabweichung * Ki                       ' I-Anteil
      Wert2_i = Wert2_i + I_anteil_alt
      If Wert2_i > 255 Then Wert2_i = 255
      If Wert2_i < 0 Then Wert2_i = 0
      I_anteil_alt = Wert2_i
      Ventilwert_soll = Wert1_i + Wert2_i                   ' P+I zusammenrechnen
      If Ventilwert_soll > Ventilwert_auf Then Ventilwert_soll = Ventilwert_auf
      If Ventilwert_soll < Ventilwert_zu Then Ventilwert_soll = Ventilwert_zu
      If Messfahrt_noetig = 0 Then
#if Test = 1
         Lcd_text = Str(ventilwert_soll) + " "
         Gosub Lcd_writetext
         Wait 5
#endif
         Wert1_i = Ventilwert_ist - Ventilwert_soll
         If Wert1_i > 5 Or Wert1_i < -5 Then Prg_step = Prg_set_ventil Else Prg_step = Prg_normalfunktion
         Prg_next_step = Prg_normalfunktion
      Else
         Prg_step = Prg_messfahrt_ventil_open
      End If

   Case Prg_set_ventil
      Reset Ventil_auf                                      'Motor anhalten (Sicher ist sicher!)
      Reset Ventil_zu
      Set Impulsgeber_enable                                'Sensor (IR-LED)einschalten
      Waitms 40
      Impulscounter = 0
      Enable Pcint0                                         'Interrupt fr Sensor einschalten.
      Prg_step = Prg_wait_for_stop
      If Ventilwert_ist > Ventilwert_soll Then              'Richtung bestimmen
         Reset Ventil_auf
         Set Ventil_zu
      Else
         Reset Ventil_zu
         Set Ventil_auf
      End If

   Case Prg_battery_empty
      If _sec.0 = 1 Then Lcd_text = "BATT " Else Lcd_text = "LEER "
      'Todo: Stromsparen, damit ggf. die Uhrzeit den folgenden Batteriewechsel bersteht.
      'Todo: Wiederkehrende Spannung registrieren und in den normalmodus wechseln.

#if Test = 1
   Case Else                                                'nur zum debuggen: hier landet man, wenn man einen step nicht definiert hat!
      Lcd_text = "ERR  "
      Gosub Lcd_writetext
      Stop
#endif
   End Select
   Gosub Lcd_writetext                                      ' dann Textausgabe

Goto Main
End                                                         'Programm



'##########################################################################
'### Battpower_adjust
'##########################################################################
'Battpower_adjust:
'  ' da die Batteriespannung ab 2,7 V falsch erkannt wird, werden die Werte fr die richtige
'  ' Erkennung des Batteriefllatandes ab 2,6 V angepasst (anpassung von 2,7 V nicht mglich,
'  ' da sonst 2,8V auch korigiert werden wrden)
'  '
'  ' Achtung: Reihenfolge der If Anweisungen muss gleich bleiben, da sonst bei einer
'  '          korrigierten Batteriespannung die Spannung erneut koprigiert wird!!!
'  Select Case Battpower
'   Case 23
'      Battpower = 22
'      Return
'   Case 24
'      Battpower = 23
'      Return
'   Case 25
'      Battpower = 24
'      Return
'   Case 26
'      Battpower = 25
'   Case 27
'      Battpower = 26
'      Return
'  End Select
'Return

'##########################################################################
'### Sekundeninterrupt
'##########################################################################
Sectic:                                                     'jede sekunde
  ' hier ggf. Timerkorrekturen fr Gangabweichung und sonstiger Kram
   If Lcd_countdown > 0 Then Decr Lcd_countdown
Return

'##########################################################################
'### Balken des Displays
'##########################################################################
'Sub Lcd_balken
'  Local Lcd_wert As Byte

'  Lcddr0 = Lcddr0 And &B00000001                            'Balken lschen
'  Lcddr1 = 0
'  Lcddr2 = Lcddr2 And &B11100000
'  Lcddr10.5 = 0
'  Lcddr11 = Lcddr11 And &B11011101
'  Lcddr12.1 = 0
'  For Lcd_count = Lcd_balkenwert_von To Lcd_balkenwert_bis  'Balken aufbauen
'    Select Case Lcd_count
'    Case 1 To 7 : Set Lcddr0.lcd_count
'    Case 8 To 10
'      Lcd_wert = Lcd_count - 8
'      Set Lcddr1.lcd_wert
'    Case 11 : Set Lcddr11.1
'    Case 12 : Set Lcddr10.5
'    Case 13 : Set Lcddr12.1
'    Case 14 : Set Lcddr11.5
'    Case 15 To 19
'      Lcd_wert = Lcd_count - 12
'      Set Lcddr1.lcd_wert
'    Case 20 To 24
'      Lcd_wert = Lcd_count - 20
'      Set Lcddr2.lcd_wert
'    End Select
'  Next I
'End Sub


'##########################################################################
'### Siebensegmentdisplay
'##########################################################################
Lcd_writetext:
  If Lcd_text <> Lcd_text_alt Then
    Temp_lcddr5 = Lcddr5 And &B00000110                     'Symbole speichern, 7segment lschen
    Temp_lcddr6 = 0
    Temp_lcddr7 = Lcddr7 And &B11111000
    Temp_lcddr10 = Lcddr10 And &B10100110
    Temp_lcddr11 = Lcddr11 And &B00100010
    Temp_lcddr12 = Lcddr12 And &B11111010

    Select Case Lcd_textchar(5)                             'Punkte neu setzen
    Case 58:                                                ' Doppelpunkt
      Set Temp_lcddr5.0
      Set Temp_lcddr10.0
    Case 46:                                                ' Punkt
      Set Temp_lcddr10.0
    End Select

    'lcd_count:stelle, Lcd_muster:bitmuster, lcd_upper:"upper-nibble", lcd_lower:"lower nibble"
    For Lcd_count = 1 To 4
      Select Case Lcd_textchar(lcd_count)                   'Bitmuster laden
      Case 35 : Lcd_muster = &B11110000                     'Gradzeichen, wir misbrauchen dafr das Doppelkreuz (#)
      Case 45 : Lcd_muster = &B00100000                     '-
      Case 48 : Lcd_muster = &B11011011                     '0
      Case 49 : Lcd_muster = &B10001000                     '1
      Case 50 : Lcd_muster = &B11100011                     '2
      Case 51 : Lcd_muster = &B11101010
      Case 52 : Lcd_muster = &B10111000
      Case 53 : Lcd_muster = &B01111010
      Case 54 : Lcd_muster = &B01111011                     '6
      Case 55 : Lcd_muster = &B11001000
      Case 56 : Lcd_muster = &B11111011
      Case 57 : Lcd_muster = &B11111010                     '9
      Case 65 : Lcd_muster = &B11111001                     'A
      Case 66 : Lcd_muster = &B00111011                     'B
      Case 67 : Lcd_muster = &B01010011
      Case 68 : Lcd_muster = &B10101011
      Case 69 : Lcd_muster = &B01110011
      Case 70 : Lcd_muster = &B01110001                     'F
      Case 71 : Lcd_muster = &B01111011
      Case 72 : Lcd_muster = &B10111001
      Case 73 : Lcd_muster = &B10001000                     'I
      Case 74 : Lcd_muster = &B10001010
      Case 75 : Lcd_muster = &B00110011
      Case 76 : Lcd_muster = &B00010011
      Case 77 : Lcd_muster = &B11101001
      Case 78 : Lcd_muster = &B00101001                     'N
      Case 79 : Lcd_muster = &B11011011                     'O
      Case 80 : Lcd_muster = &B11110001                     'P
      Case 81 : Lcd_muster = &B11011011                     'Q
      Case 82 : Lcd_muster = &B00100001                     'R
      Case 83 : Lcd_muster = &B01111010                     'S
      Case 84 : Lcd_muster = &B00110011                     'T
      Case 85 : Lcd_muster = &B10011011
      Case 86 : Lcd_muster = &B10011011
      Case 87 : Lcd_muster = &B10011011
      Case 88 : Lcd_muster = &B10111001
      Case 89 : Lcd_muster = &B10111010
      Case 90 : Lcd_muster = &B11100011                     'Z
      Case 105 : Lcd_muster = &B00000001                    'kleines i
      Case Else : Lcd_muster = &B00000000                   'Space
      End Select

      If Lcd_count.0 = 1 Then                               ' 1. und 3.Stelle
        Lcd_upper = Lcd_muster And &B11110000               'lcddr5 (stelle1) bzw lcddr6(stelle3)
        Rotate Lcd_upper , Right , 1
        Lcd_lower = Lcd_muster And &B00001011               'lcddr10(stelle1) bzw lcddr11(stelle3)
        Rotate Lcd_lower , Left , 3
        If Lcd_count = 1 Then                               'i=1
          Temp_lcddr5 = Temp_lcddr5 Or Lcd_upper            'Lcddr5 Or Lcd_upper
          Temp_lcddr10 = Temp_lcddr10 Or Lcd_lower
        Else                                                'i=3
          Temp_lcddr6 = Temp_lcddr6 Or Lcd_upper
          Temp_lcddr11 = Temp_lcddr11 Or Lcd_lower
        End If
      Else                                                  'grade
        Lcd_upper = Lcd_muster And &B11100000               'lcddr6(stelle2) bzw lcddr7(stelle4)
        Rotate Lcd_upper , Right , 5
        Lcd_lower = Lcd_muster And &B00001010               'lcddr11(stelle2) bzw lcddr12(stelle4)
        Rotate Lcd_lower , Right , 1
        If Lcd_count = 2 Then                               'i=2
          Temp_lcddr5.7 = Lcd_muster.4
          Temp_lcddr6 = Temp_lcddr6 Or Lcd_upper
          Temp_lcddr10.7 = Lcd_muster.0
          Temp_lcddr11 = Temp_lcddr11 Or Lcd_lower
        Else                                                'i=4
          Temp_lcddr6.7 = Lcd_muster.4
          Temp_lcddr7 = Temp_lcddr7 Or Lcd_upper
          Temp_lcddr11.7 = Lcd_muster.0
          Temp_lcddr12 = Temp_lcddr12 Or Lcd_lower
        End If
      End If
    Next I
    Lcddr5 = Temp_lcddr5
    Lcddr6 = Temp_lcddr6
    Lcddr7 = Temp_lcddr7
    Lcddr10 = Temp_lcddr10
    Lcddr11 = Temp_lcddr11
    Lcddr12 = Temp_lcddr12
  End If
  Lcd_text_alt = Lcd_text
Return

'##########################################################################
'### SPI16 zur ansteuerung des RFM12-Moduls
'##########################################################################
'Sub Spi16
'  Nsel = 0
'  For Count = 1 To 16
'       Sdi = Rfm12_dataword.15
'       Shift Rfm12_dataword , Left
'       Rfm12_dataword.0 = Sdo
'       Set Sck
'       Reset Sck
'  Next
'  Nsel = 1
'End Sub

'##########################################################################
'### Interrupt Routine fr Timer0 (Notaus/Getriebeerkennung fr Motor)
'##########################################################################
Timer0_int:                                                 'Wenn Timer berluft, dann Motor aus
   Reset Ventil_auf
   Reset Ventil_zu
   #if Test
      Toggle Lcd_frost
   #endif
   Stop Timer0
   Waitms 40                                                'kurze Pause, damit motor am Getriebeende zurckdrehen kann!
   Disable Pcint0
   Reset Impulsgeber_enable                                 'Sensor (IR-LED)ausschalten
Return

'##########################################################################
'### Interrupt Routine fr Timer1 (Tastenerkennung)
'##########################################################################
Timer1_int:
   Readkey = Not Pinb                                       '
   Readkey = Readkey And Key_port
   If Readkey > 0 Then Incr Key_pressed_counter Else Key_pressed_counter = 0
   Entprell_helper = Key_pressed_counter Mod 6
   If Key_pressed_counter => 2 Then Set Tempkey.keypressed Else Reset Tempkey.keypressed
   If Key_pressed_counter = 2 Or Entprell_helper = 5 Then Tempkey = Tempkey Or Readkey
   If Key_pressed_counter > 30 And Tempkey.keypressed = 1 Then Set Tempkey.longpressed Else Reset Tempkey.longpressed
Return

'#########################################################################
'### lst aus, wenn sich der Motor dreht und der Impulsgeber triggert
'#########################################################################
Impulsgeber_int:
   If Impulsgeber_pin = 1 Then                              'nur eine flanke
      Stop Timer0
      Incr Impulscounter
      If Ventil_auf = 1 Then                                ' Motor luft
         Incr Ventilwert_ist                                ' das zhlen wir dann
      Else
         Decr Ventilwert_ist                                ' auch das Zufahren
      End If
      If Ventilwert_ist = Ventilwert_soll Then              'Zielposition erreicht ?
         Reset Ventil_auf                                   'Motor aus
         Reset Ventil_zu
      End If
      If Impulscounter > 5 Then                             'Anlaufverzgerung
         If Messfahrt_noetig = 1 And Ventil_zu = 1 Then     'wenn Messfahrt
            If Timer0 < Leerlaufticks Then Leerlaufticks = Timer0       'leerlaufgeschwindigkeit ermitteln
            Wert1_w = Leerlaufticks + Pin_offset
            If Ventilwert_auf = 0 And Timer0 > Wert1_w Then
              Ventilwert_auf = Ventilwert_ist               'pinberhrung=ventilwert_offen erkennen
               Leerlaufticks = 9999                         'leerlaufticks neu berechnen
               Impulscounter = 0
               #if Test
                  Set Lcd_mond
               #endif
            End If
            Wert1_w = Leerlaufticks + Close_offset
            If Ventilwert_zu = 0 And Timer0 > Wert1_w Then  'ventilwert_zu erkennen
               Ventilwert_zu = Ventilwert_ist
               Reset Ventil_zu
               #if Test
                  Set Lcd_sonne
               #endif
            End If
         End If
         Config Timer0 = Timer , Prescale = 64
      Else
         Config Timer0 = Timer , Prescale = 1024            'Anlaufverzgerung
      End If
      #if Test
         Lcd_text = "     "
         Lcd_text = Str(ventilwert_ist)
         Lcd_countdown = 5
      #endif
      Timer0 = 0
      If Ventil_auf = 1 Or Ventil_zu = 1 Then Start Timer0
   End If
Return

'##########################################################################
'### Data mit den Temperaturen
'##########################################################################
Adc_val:
  Data 195%                                                 ' Temperatur 55 Grad
  Data 228%                                                 ' Temperatur 50 Grad
  Data 266%                                                 ' Temperatur 45 Grad
  Data 308%                                                 ' Temperatur 40 Grad
  Data 356%                                                 ' Temperatur 35 Grad
  Data 409%                                                 ' Temperatur 30 Grad
  Data 465%                                                 ' Temperatur 25 Grad
  Data 525%                                                 ' Temperatur 20 Grad
  Data 585%                                                 ' Temperatur 15 Grad
  Data 645%                                                 ' Temperatur 10 Grad
  Data 703%                                                 ' Temperatur  5 Grad
  Data 757%                                                 ' Temperatur  0 Grad
  Data 807%                                                 ' Temperatur -5 Grad

'#############################
'### Data fr RFM12
'#############################
Rfm12_init:
  Data &H80D7%                                              ' El , Ef , 11.5pf, 433 MHz band ' fr 868MHz Band &H80e7
  Data &H82D9%                                              '!er , !ebb , Et , Es , Ex , !eb , !ew , Dc
  Data &HA67C%                                              ' 434,15 MHz / 868,3 MHz
  Data &HC647%                                              ' 4.8kbps
  Data &H94A4%                                              ' Vdi , Fast , 134 kHz , 0db , -79dbm
  Data &HC2AC%                                              ' Al , !ml , Dig , Dqd4
  Data &HCA81%                                              ' Fifo8 , Sync , !ff , Dr
  Data &HC483%                                              ' @pwr , No Rstric , !st , !fi , Oe , En
  Data &H9850%                                              ' 90 kHz , power - 0 dB
  Data &HE000%                                              '
  Data &HC800%                                              '
  Data &HC000%

Rfm12_receive:                                              'Emfang einschalten
  Data &H82C8%
  Data &HCA83%                                              '

Rfm12_send:                                                 'Sender einschalten
  Data &H8238%
  Data &HB8AA%
  Data &HB8AA%
  Data &HB8AA%
  Data &HB82D%
  Data &HB8D4%

Rfm12_send_over:                                            'Sender ausschalten
  Data &HB8AA%
  Data &HB8AA%
  Data &H8208%